import java.util.Scanner;

public class ilovewavelettrees_dmg {
    static long BIG = Long.MAX_VALUE;
    static long LITTLE = Long.MIN_VALUE;

    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);

        int N = in.nextInt();
        int K = in.nextInt();
        int[] h = new int[N];
        for(int n=0;n<N;n++) {
            h[n] = in.nextInt();
        }
        int[] a = new int[N];
        for(int n=0;n<N;n++) {
            a[n] = in.nextInt();
        }

        System.out.println(solve(N,K,h,a));
    }

    static long solve(int N, int K, int[] h, int[] a) {

        Data data = new Data();
        data.N = N;
        data.K = K;
        data.h = h;
        data.a = a;

        data.arr = new long[N];
        for(int n=0;n<N;n++) {
            data.arr[n] = score(h[n], K, a[n]);
        }
        data.diffifswap = new long[N];
        for(int n=0;n<N;n++) {
            data.diffifswap[n] = data.arr[n] - score(a[n], K, h[n]);
        }

        data.wlt = new Wave(data.diffifswap);

        data.arrsum = new long[N+1];
        for(int n=0;n<N;n++) {
            data.arrsum[n+1] = data.arrsum[n] + data.arr[n];
        }

        data.wltsum = new Wave(data.arrsum);

        long ans = go(data, 0, N);

        return ans;
    }

    static long go(Data data, int lch, int rch) {
        if (lch == rch) return 0L;
        if (lch + 1 == rch) return (data.h[lch] - data.a[lch] == 0)? 1L: 0L;

        // find the worst possible swap location, if there is one.
        int swapDex = data.wlt.kthSmallest(rch-lch, lch, rch);

        long worse = Math.min(
                score(data.a[swapDex], data.K, data.h[swapDex]),
                score(data.h[swapDex],  data.K, data.a[swapDex]));
        long offset = data.arr[swapDex] - worse;

        boolean leftHeavy = (swapDex - lch) < (rch - swapDex - 1);
        long count = 0;
        if (leftHeavy) {
            long threshold = data.arrsum[swapDex] + offset;
            for(int start = swapDex; lch <= start; start--) {
                if (start != swapDex) {
                    threshold -= data.arr[start];
                }
                long res = data.wltsum.numValsBtwn(threshold, BIG, swapDex+1, rch+1);
                count += res;
            }
        }
        else {
            long threshold = data.arrsum[swapDex+1] - offset;
            for(int end = swapDex + 1; end <= rch; end++) {
                if (end != swapDex+1) {
                    threshold += data.arr[end-1];
                }
                long res = data.wltsum.numValsBtwn(LITTLE, threshold, lch, swapDex+1);
                count += res;
            }
        }

        long left = go(data, lch, swapDex);
        long right = go(data, swapDex+1, rch);
        return count + left + right;
    }

    static int score(int h, int k, int a) {
        if (h < a) return (h - a)*k;
        return h - a;
    }

    static class Data {
        int N, K, h[], a[];
        long arr[], diffifswap[], arrsum[];
        Wave wlt, wltsum;

    }

    static class Wave {
        long s = BIG, b = LITTLE; int N;
        long[] arr; int[] dex, sPtr;
        Wave sWav = null, bWav = null;
        Wave(long[] arr) {
            this(arr.clone(), null);
        }
        Wave(long[] arr, int[] dex) {
            this.arr = arr;
            if (dex == null) {
                dex = new int[arr.length];
                for(int n=0;n< dex.length; n++) dex[n] = n;
            }
            this.dex = dex;
            N = dex.length;

            for(int n=0;n<N;n++) {
                s = Math.min(s, arr[dex[n]]);
                b = Math.max(b, arr[dex[n]]);
            }
            sPtr = new int[N+1];
            for(int n=0;n<N;n++) {
                sPtr[n+1] = sPtr[n];
                if(arr[dex[n]] <= s + (b-s) / 2) sPtr[n+1]++;
            }
            if (s == b) return;

            int[] sDex = new int[sPtr[N]];
            int[] bDex=  new int[N - sPtr[N]];
            for(int n=0;n<N;n++){
                if (sPtr[n] != sPtr[n+1]) sDex[sPtr[n]] = dex[n];
                else bDex[n - sPtr[n]] = dex[n];
            }
            sWav = new Wave(arr, sDex);
            bWav = new Wave(arr, bDex);
        }

        int kthSmallest(int k, int l, int r) {
            if (s == b) return dex[l+k-1];
            if(sPtr[r] - sPtr[l] >= k) return
                    sWav.kthSmallest(k, sPtr[l], sPtr[r]);
            return
                    bWav.kthSmallest(k-sPtr[r]+sPtr[l], l-sPtr[l],r-sPtr[r]);
        }

        int numValsBtwn(long ss, long bb, int l, int r) {
            if(ss <= s && b <= bb) return r-l;
            if(bb < s || b < ss || s == b) return 0;
            return sWav.numValsBtwn(ss,bb,sPtr[l], sPtr[r]) + bWav.numValsBtwn(ss,bb,l-sPtr[l],r-sPtr[r]);
        }
    }
}
